=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-01-23 16:24:25 +0000
+++ branchview/treeview.py	2008-01-23 16:36:21 +0000
@@ -390,6 +390,7 @@
             menu = RevisionPopupMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
+            menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))
             menu.popup(None, None, None, event.button, event.get_time())
 
     def _on_revision_activated(self, widget, path, col):

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2007-11-21 23:49:58 +0000
+++ revisionmenu.py	2008-01-23 16:36:21 +0000
@@ -23,10 +23,20 @@
 
 import bzrlib
 import gtk
+import gobject
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
 class RevisionPopupMenu(gtk.Menu):
+
+    __gsignals__ = {
+            'tag-added': (
+                gobject.SIGNAL_RUN_FIRST,
+                gobject.TYPE_NONE,
+                (gobject.TYPE_STRING, gobject.TYPE_STRING)
+            )
+    }
+
     def __init__(self, repository, revids, branch=None, wt=None):
         super(RevisionPopupMenu, self).__init__()
         self.branch = branch
@@ -100,11 +110,7 @@
             dialog.hide()
         
             if response == gtk.RESPONSE_OK:
-                try:
-                    self.branch.lock_write()
-                    self.branch.tags.set_tag(dialog.tagname, dialog._revid)
-                finally:
-                    self.branch.unlock()
+                self.emit('tag-added', dialog.tagname, dialog._revid)
             
             dialog.destroy()
     

